declare filename "VibratorBass_013vstib.dsp"; declare name "VibratorBass_013vstib"; // ██╗   ██╗██╗██████╗ ██████╗  █████╗ ████████╗ ██████╗ ██████╗ 
// ██║   ██║██║██╔══██╗██╔══██╗██╔══██╗╚══██╔══╝██╔═══██╗██╔══██╗
// ██║   ██║██║██████╔╝██████╔╝███████║   ██║   ██║   ██║██████╔╝
// ╚██╗ ██╔╝██║██╔══██╗██╔══██╗██╔══██║   ██║   ██║   ██║██╔══██╗
//  ╚████╔╝ ██║██████╔╝██║  ██║██║  ██║   ██║   ╚██████╔╝██║  ██║
//   ╚═══╝  ╚═╝╚═════╝ ╚═╝  ╚═╝╚═╝  ╚═╝   ╚═╝    ╚═════╝ ╚═╝  ╚═╝
// ██████╗  █████╗ ███████╗███████╗
// ██╔══██╗██╔══██╗██╔════╝██╔════╝
// ██████╔╝███████║███████╗███████╗
// ██╔══██╗██╔══██║╚════██║╚════██║
// ██████╔╝██║  ██║███████║███████║
// ╚═════╝ ╚═╝  ╚═╝╚══════╝╚══════╝                       
// ╔╦╗╔═╗╔═╗╦═╗╔═╗  ╔╦╗╔═╗╔═╗╦ ╦╦╔╗╔╔═╗╔═╗
// ║║║╠═╣║  ╠╦╝║ ║  ║║║╠═╣║  ╠═╣║║║║║╣ ╚═╗
// ╩ ╩╩ ╩╚═╝╩╚═╚═╝  ╩ ╩╩ ╩╚═╝╩ ╩╩╝╚╝╚═╝╚═╝

import("stdfaust.lib");
import("maxmsp.lib");

declare name "Virtual Vibrator";
declare author "Nico Raftis";
declare copyright "Copyright (c) 2020, Macro Machines Engineering";
declare version "0.0.1";
declare license "GPLv2.0";






//  ██████╗ ███████╗ ██████╗██╗██╗     ██╗      █████╗ ████████╗ ██████╗ ██████╗ 
// ██╔═══██╗██╔════╝██╔════╝██║██║     ██║     ██╔══██╗╚══██╔══╝██╔═══██╗██╔══██╗
// ██║   ██║███████╗██║     ██║██║     ██║     ███████║   ██║   ██║   ██║██████╔╝
// ██║   ██║╚════██║██║     ██║██║     ██║     ██╔══██║   ██║   ██║   ██║██╔══██╗
// ╚██████╔╝███████║╚██████╗██║███████╗███████╗██║  ██║   ██║   ╚██████╔╝██║  ██║
//  ╚═════╝ ╚══════╝ ╚═════╝╚═╝╚══════╝╚══════╝╚═╝  ╚═╝   ╚═╝    ╚═════╝ ╚═╝  ╚═╝
                                                                                      
// au.dirac; -------------------------------------------------------------------
//
// Dirac impulse: full-amplitude, 1-sample impulse.
// y[n] = 1 if n = 0; 0 otherwise.
//
// 0 inputs.
//
// 1 outputs: 
//    y[n].
//
dirac = 1 - 1';

// o2.osc_quad(F[n]); ----------------------------------------------------------
//
// Recursive quadrature oscillator by Martin Vicanek. This design is
// arguably the best recursive quadrature oscillator available in the
// literature. The system shows long-term stability as well as accuracy at
// low frequencies. 
//
// Ref: https://vicanek.de/articles/QuadOsc.pdf.
//
// 1 inputs:
//    F[n], oscillator frequency in Hz.
//
// 2 outputs:
//    y1[n], cosine (real part);
//    y2[n], sine (imaginary part).
//
osc_quad(f) =  tick 
               ~ ( _ , 
                   _)
      with {
           k1 = tan(ma.PI * f / ma.SR);
           k2 = 2 * k1 / (1 + k1 * k1);
           tick(u, v) =    omega - k1 * (v + k2 * omega) , 
                           v + k2 * omega
           with {
               omega = (u + dirac) - k1 * v;
           };
      };

osc_quad_sin(f) = osc_quad(f) : !,_ ;


// o2.ph(F[n], R[n]); ----------------------------------------------------------
//
// Phasor with reset input.
//
// Note: the arguments of the function should be inverted for
// consistency, but that requires checking for backward compatibility.
//
// 2 inputs:
//    F[n], frequency in Hz;
//    R[n], reset phasor to zero if R[n] != 0.
//
// 1 outputs:
//    y[n], phasor output.
//
ph(freq, reset) =  (+ (freq / ma.SR * r) : ma.decimal)
                   ~ * (r)
      with {
           r = reset == 0;
      };







// ███████╗██╗██╗  ████████╗███████╗██████╗ ███████╗
// ██╔════╝██║██║  ╚══██╔══╝██╔════╝██╔══██╗██╔════╝
// █████╗  ██║██║     ██║   █████╗  ██████╔╝███████╗
// ██╔══╝  ██║██║     ██║   ██╔══╝  ██╔══██╗╚════██║
// ██║     ██║███████╗██║   ███████╗██║  ██║███████║
// ╚═╝     ╚═╝╚══════╝╚═╝   ╚══════╝╚═╝  ╚═╝╚══════╝
//===================================Korg 35 Filters====================================
// The following filters are virtual analog models of the Korg 35 low-pass 
// filter and high-pass filter found in the MS-10 and MS-20 synthesizers.
// The virtual analog models for the LPF and HPF are different, making these 
// filters more interesting than simply tapping different states of the same 
// circuit. 
//
// These filters were implemented in Faust by Eric Tarr during the 
// [2019 Embedded DSP With Faust Workshop]
// (https://ccrma.stanford.edu/workshops/faust-embedded-19/).
//
// #### Filter history:
//
// <https://secretlifeofsynthesizers.com/the-korg-35-filter/>
//========================================================================================

//------------------`(ve.)korg35LPF`-----------------
// Virtual analog models of the Korg 35 low-pass filter found in the MS-10 and 
// MS-20 synthesizers.
//
// #### Usage
//
// ```
// _ : korg35LPF(normFreq,Q) : _
// ```
//
// Where:
//
// * `normFreq`: normalized frequency (0-1)
// * `Q`: q
//---------------------------------------------------------------------

declare korg35LPF author "Eric Tarr";
declare korg35LPF license "MIT-style STK-4.3 license";

korg35LPF(normFreq,Q) = _ <: (s1,s2,s3,y) : !,!,!,_
letrec{
  's1 = _-s1:_*(alpha*2):_+s1;
  's2 = _-s1:_*alpha:_+s1:_+(s3*B3):_+(s2*B2):_*alpha0:_-s3:_*alpha:_+s3:_*K:_-s2:_*(alpha*2):_+s2;
  's3 = _-s1:_*alpha:_+s1:_+(s3*B3):_+(s2*B2):_*alpha0:_-s3:_*(alpha*2):_+s3;
  'y = _-s1:_*alpha:_+s1:_+(s3*B3):_+(s2*B2) :_*alpha0:_-s3:_*alpha:_+s3;
}
with{
  freq = 2*(10^(3*normFreq+1));
  K = 2.0*(Q - 0.707)/(10.0 - 0.707);
  wd = 2*ma.PI*freq;
  T = 1/ma.SR;
  wa = (2/T)*tan(wd*T/2);
  g = wa*T/2; 
  G = g/(1.0 + g);
  alpha = G;
  B3 = (K - K*G)/(1 + g);
  B2 = -1/(1 + g);
  alpha0 = 1/(1 - K*G + K*G*G); 
};


//------------------`(ve.)korg35HPF`-----------------
// Virtual analog models of the Korg 35 high-pass filter found in the MS-10 and 
// MS-20 synthesizers.
//
// #### Usage
//
// ```
// _ : korg35HPF(normFreq,Q) : _
// ```
//
// Where:
//
// * `normFreq`: normalized frequency (0-1)
// * `Q`: q
//---------------------------------------------------------------------

declare korg35HPF author "Eric Tarr";
declare korg35HPF license "MIT-style STK-4.3 license";

korg35HPF(normFreq,Q) = _ <: (s1,s2,s3,y) : !,!,!,_
letrec{
  's1 = _-s1:_*(alpha*2):_+s1;
  's2 = _<:(_-s1:_*alpha:_+s1)*-1,_:>_+(s3*B3):_+(s2*B2):_*alpha0:_*K:_-s2:_*alpha*2:_+s2;
  's3 = _<:(_-s1:_*alpha:_+s1)*-1,_:>_+(s3*B3):_+(s2*B2):_*alpha0:_*K:_<:(_-s2:_*alpha:_+s2)*-1,_:>_-s3:_*alpha*2:_+s3;
  'y = _<:(_-s1:_*alpha:_+s1)*-1,_:>_+(s3*B3):_+(s2*B2):_*alpha0;
}
with{
  freq = 2*(10^(3*normFreq+1));
  K = 2.0*(Q - 0.707)/(10.0 - 0.707);
  wd = 2*ma.PI*freq;
  T = 1/ma.SR;
  wa = (2/T)*tan(wd*T/2);
  g = wa*T/2; 
  G = g/(1.0 + g);
  alpha = G;
  B3 = 1.0/(1.0 + g);
  B2 = -1.0*G/(1.0 + g);
  alpha0 = 1/(1 - K*G + K*G*G);
};



                                   

// ███████╗███╗   ██╗██╗   ██╗███████╗██╗      ██████╗ ██████╗ ███████╗
// ██╔════╝████╗  ██║██║   ██║██╔════╝██║     ██╔═══██╗██╔══██╗██╔════╝
// █████╗  ██╔██╗ ██║██║   ██║█████╗  ██║     ██║   ██║██████╔╝█████╗  
// ██╔══╝  ██║╚██╗██║╚██╗ ██╔╝██╔══╝  ██║     ██║   ██║██╔═══╝ ██╔══╝  
// ███████╗██║ ╚████║ ╚████╔╝ ███████╗███████╗╚██████╔╝██║     ███████╗
// ╚══════╝╚═╝  ╚═══╝  ╚═══╝  ╚══════╝╚══════╝ ╚═════╝ ╚═╝     ╚══════╝
                                                                            
//------------------------`(en.)adsre`----------------------
// ADSRE (Attack, Decay, Sustain, Release) envelope generator with Exponential 
// segments.
//
// #### Usage
//
// ```
// adsre(a,d,s,r,g) : _
// ```
//
// Where:
//
// * `a`: attack (sec)
// * `d`: decay (sec)
// * `s`: sustain (fraction of `t`: 0-1)
// * `r`: release (sec)
// * `t`: trigger signal (attack is triggered when `t>0`, release is triggered
// when `t=0`)
//-----------------------------------------------------
// Author: JOS
// License: STK-4.3

adsre(attT60,decT60,susLvl,relT60,gate) = envelope with {
  ugate = gate>0;
  samps = ugate : +~(*(ugate)); // ramp time in samples
  attSamps = int(attT60 * ma.SR);
  target = select2(ugate, 0.0,
           select2(samps<attSamps, (susLvl)*float(ugate), ugate));
  t60 = select2(ugate, relT60, select2(samps<attSamps, decT60, attT60));
  pole = ba.tau2pole(t60/6.91);
  envelope = target : si.smooth(pole);
};







////////////////////////////////////////////////////////////////////////////////
//
//    ██████╗ ██████╗ ███╗   ██╗████████╗██████╗  ██████╗ ██╗     ███████╗
//   ██╔════╝██╔═══██╗████╗  ██║╚══██╔══╝██╔══██╗██╔═══██╗██║     ██╔════╝
//   ██║     ██║   ██║██╔██╗ ██║   ██║   ██████╔╝██║   ██║██║     ███████╗
//   ██║     ██║   ██║██║╚██╗██║   ██║   ██╔══██╗██║   ██║██║     ╚════██║
//   ╚██████╗╚██████╔╝██║ ╚████║   ██║   ██║  ██║╚██████╔╝███████╗███████║
//    ╚═════╝ ╚═════╝ ╚═╝  ╚═══╝   ╚═╝   ╚═╝  ╚═╝ ╚═════╝ ╚══════╝╚══════╝
//
////////////////////////////////////////////////////////////////////////////////

normMIDI(mv)  = mv/127.0; 

vol  = normMIDI(hslider("Ctrl Value IN (Ctrl 1) [midi:ctrl 1]", 60, 0, 127, 1)) ;

// MIDI
f    = nentry(  "freq", 200, 40, 2000, 0.01)        : si.polySmooth(t, 0.999, 1);
bend = hslider( "bend", 1,0, 10, 0.01)              : si.polySmooth(t, 0.999, 1);
g    = nentry(  "gain", 1,0, 1, 0.01);
t    = button(  "gate");
freq = f * bend;
ff   = f / 2000;
motorFreq = f * adsrenvelope;

// ENVELOPE
torque       = hslider("Torque", 0.333, 0.125, 1.0, 0.01)            : si.smoo;
envelope     = t * g * vol                                           : si.smoo;
adsrenvelope = en.adsre(torque,torque,1.0,0.5,t);

// FM
ratio = hslider("ratio", 1.03,  0.0, 8.0,   0.01 )                   : si.smoo;
index = hslider("index", 36.46, 0.0, 500.0, 0.01 )                   : si.smoo;

// FILTERS
lpQ    = hslider("Low Pass Q", 5.61, 0.5, 7.9, 0.01 )                : si.smoo;
lpFreq = hslider("Low Pass Freq", 0.49, 0, 1, 0.001 )                : si.smoo;
lpKey  = hslider("Low Pass Keyboard Tracking", 0.09, 0, 1, 0.001 )   : si.smoo;
lpF    = lpFreq + (ff * lpKey);

hpQ    = hslider("High Pass Q",     4.88, 0.5, 10,  0.01  )          : si.smoo;
hpFreq = hslider("High Pass Freq",  0.135, 0,   1,  0.001 )          : si.smoo;
hpKey  = hslider("High Pass Keyboard Tracking", 0.09, 0, 1, 0.001 )  : si.smoo;
hpF    = hpFreq + (ff * hpKey);

// PEAK NOTCH
peakNotchGain = hslider("Gain [unit: lin]", 0.17, 0, 8, 0.01)        : si.smoo;
peakNotchFreq = hslider("FreqNotch", 1000, 100, 1000, 1)             : si.smoo;
peakNotchQ    = hslider("Q", 2, 0.1, 100, 0.01)                      : si.smoo;

peakNotchFX(x) = peakNotch( x, peakNotchFreq, peakNotchGain, peakNotchQ);




// DISTORTION
hardness = hslider("Harhdness", 0.5, 0.5, 10.0, 0.001 ) : si.smoo;






// NOISE BRUSHES





// ███████╗███████╗███████╗███████╗ ██████╗████████╗███████╗
// ██╔════╝██╔════╝██╔════╝██╔════╝██╔════╝╚══██╔══╝██╔════╝
// █████╗  █████╗  █████╗  █████╗  ██║        ██║   ███████╗
// ██╔══╝  ██╔══╝  ██╔══╝  ██╔══╝  ██║        ██║   ╚════██║
// ███████╗██║     ██║     ███████╗╚██████╗   ██║   ███████║
// ╚══════╝╚═╝     ╚═╝     ╚══════╝ ╚═════╝   ╚═╝   ╚══════╝
                                                         








//  ██████╗ ██╗   ██╗████████╗██████╗ ██╗   ██╗████████╗
// ██╔═══██╗██║   ██║╚══██╔══╝██╔══██╗██║   ██║╚══██╔══╝
// ██║   ██║██║   ██║   ██║   ██████╔╝██║   ██║   ██║   
// ██║   ██║██║   ██║   ██║   ██╔═══╝ ██║   ██║   ██║   
// ╚██████╔╝╚██████╔╝   ██║   ██║     ╚██████╔╝   ██║   
//  ╚═════╝  ╚═════╝    ╚═╝   ╚═╝      ╚═════╝    ╚═╝   
                                                     

process = osc_quad( motorFreq + osc_quad_sin( motorFreq * ratio ) *index )
        : *(vol),                   *(vol)
        : *(adsrenvelope),          *(adsrenvelope) 
        : ve.korg35HPF(hpF,hpQ),    ve.korg35HPF(hpF,hpQ) 
        : ve.korg35LPF(lpF,lpQ),    ve.korg35LPF(lpF,lpQ) 
        : *(hardness),              *(hardness) 
        : ma.tanh,                  ma.tanh 
        : peakNotchFX,              peakNotchFX 
        : co.limiter_1176_R4_stereo;